/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package colaborar;

import java.io.BufferedReader;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.ServerSocket;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.Scanner;

/**
 *
 * @author kyman
 */
public class Colaborar {
    
    // Configuración.
    private static final int numero_instancias = 10;
    private static final String path_absoluto = "/home/DAM2024/PSP01_Tarea";
    private static final String lenguaje_path = path_absoluto + "/Actividad2/lenguaje/dist/lenguaje.jar";
    private static final int puerto = 45338;
    // Configuración.
    
    public static boolean trabajando = true;
    private static ServerSocket socket;
    private static final ArrayList<Socket> clientes = new ArrayList<>();
    private static final ArrayList<PrintWriter> salidas = new ArrayList<>();
    private static boolean ocupado = false;
    private static int clientes_cerrados = 0;
    private static Scanner entrada;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        
        if(iniciar_servidor()){
            
            iniciar_terminal();
            
            for(int i = 0; i < numero_instancias; i ++)
                try {
                    
                    Process proceso = Runtime.getRuntime().exec("java -jar " + lenguaje_path + " " + ((i + 1) * 10) + " " + path_absoluto + "/diccionario.txt");
                    BufferedReader entrada = new BufferedReader(new InputStreamReader(proceso.getInputStream()));
                    BufferedReader errores = new BufferedReader(new InputStreamReader(proceso.getErrorStream()));

                    new Thread(new Runnable(){
                        @Override
                        public void run() {
                            try {
                                
                                String mensaje;
                                
                                while((mensaje = entrada.readLine()) != null)
                                    System.out.println(mensaje);
                            } catch (IOException excepcion) {
                                Colaborar.excepcion(excepcion);
                            }
                        }
                    }).start();

                    new Thread(new Runnable(){
                        @Override
                        public void run() {
                            try {
                                
                                String mensaje;
                                
                                while((mensaje = errores.readLine()) != null)
                                    System.out.println(mensaje);
                            } catch (IOException excepcion) {
                                Colaborar.excepcion(excepcion);
                            }
                        }
                    }).start();
                    
                } catch (IOException excepcion) {
                    Colaborar.excepcion(excepcion);
                }
            
        }else 
            System.out.println("Hubo un error al intentar lanzar el Socket servidor en el puerto " + puerto + ".");
        
    }
    
    public static void excepcion(Exception exception){
        System.out.println(exception.getMessage());
        System.out.println(Arrays.toString(exception.getStackTrace()));
    }
    
    private static void iniciar_terminal(){
        new Thread(new Runnable(){
            @Override
            public void run() {
                
                entrada = new Scanner(System.in);
        
                while(trabajando){

                    String mensaje = entrada.nextLine();

                    if(!mensaje.trim().isEmpty())
                        switch(mensaje){
                            case "close", "cerrar", "bye", "exit", "terminar" -> cerrar();
                            default -> System.out.println("Comando desconocido.");
                        }

                }
                
                entrada.close();
        
            }
        }).start();
    }
    
    private static boolean iniciar_servidor(){
        
        boolean exito = false;
        
        try{
            new Thread(new Runnable(){
                @Override
                public void run() {
                    try{

                        socket = new ServerSocket(puerto);

                        while(trabajando){

                            Socket cliente = socket.accept();
                            PrintWriter salida = new PrintWriter(cliente.getOutputStream());
                            int i = 0;
                            int l = clientes.size();

                            for(; i < l; i++)
                                if(clientes.get(i) == null)
                                    break;
                            if(i == l){
                                clientes.add(cliente);
                                salidas.add(salida);
                            }else{
                                clientes.set(i, cliente);
                                salidas.set(i, salida);
                            }
                            
                            escuchar(i, new BufferedReader(new InputStreamReader(cliente.getInputStream())));

                        }

                    }catch(IOException excepcion){
                        // ColaborarB.excepcion(excepcion);
                    }
                }

            }).start();
            exito = true;
        }catch(Exception excepcion){
            Colaborar.excepcion(excepcion);
        }
        
        return exito;
    }
    
    private static void escuchar(int i, BufferedReader entrada){
        new Thread(new Runnable(){
            @Override
            public void run() {
                
                String mensaje;
                
                try{
                    while((mensaje = entrada.readLine()) != null){
                        System.out.println("SERVIDOR - REC => " + mensaje);
                        switch(mensaje){
                            case "permiso" -> {
                                if(ocupado)
                                    enviar(i, "permiso No");
                                else{
                                    ocupado = true;
                                    enviar(i, "permiso Sí");
                                }
                            }
                            case "terminado" -> ocupado = false;
                            case "cerrar" -> {
                                if((clientes_cerrados += 1) == numero_instancias)
                                    cerrar();
                            }
                        }
                    }
                    entrada.close();
                }catch(IOException excepcion) {
                    // ColaborarB.excepcion(excepcion);
                }
                
                cerrar_cliente(i);
                    
            }
        }).start();
    }
    
    private static boolean enviar(int i, String mensaje){
        
        boolean estado = false;
        
        try{
            new Thread(new Runnable() {
                @Override
                public void run() {
                    
                    PrintWriter salida = salidas.get(i);
                    
                    System.out.println("SERVIDOR - ENV => " + mensaje);
                    salida.println(mensaje);
                    salida.flush();
                    
                }
            }).start();
            estado = true;
        }catch(Exception excepcion){
            Colaborar.excepcion(excepcion);
        }
        
        return estado;
    }
    
    private static boolean cerrar_cliente(int i){
        
        boolean exito = false;
        Socket cliente = clientes.get(i);
        
        if(cliente != null){
            try {
                
                PrintWriter salida = salidas.get(i);
                
                if(salida != null)
                    salida.close();
                cliente.close();
                clientes.set(i, null);
                
                exito = true;
                
            } catch (IOException excepcion) {
                Colaborar.excepcion(excepcion);
            }
        }
        
        return exito;
    }
    
    public static boolean cerrar(){
        
        boolean exito = false;
        
        trabajando = false;
        
        if(entrada != null){
            System.out.println("La aplicación ha terminado. Por favor, presione \"ENTER\" para salir de la aplicación.");
            entrada.close();
        }
        
        if(socket != null){
        
            for(int i = 0, l = clientes.size(); i < l; i ++)
                cerrar_cliente(i);

            try {
                socket.close();
                exito = true;
            } catch (IOException excepcion) {
                Colaborar.excepcion(excepcion);
            }
            
        }
        
        return exito;
    }
    
}
