/*
 * Click nbfs://nbhost/SystemFileSystem/Templates/Licenses/license-default.txt to change this license
 * Click nbfs://nbhost/SystemFileSystem/Templates/Classes/Main.java to edit this template
 */
package lenguaje;

import java.io.BufferedReader;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileNotFoundException;
import java.io.FileWriter;
import java.io.IOException;
import java.io.InputStreamReader;
import java.io.PrintWriter;
import java.net.Socket;
import java.util.Arrays;

/**
 *
 * @author kyman
 */
public class Lenguaje {
    
    // Configuración.
    private static final int puerto = 45338;
    private static final String host = "localhost";
    private static int numero_de_palabras = 40;
    private static String path = "../../diccionario.txt";
    private static final String alfabeto = "ABCDEFGHIJKLMNOPQRSTUVWXYZ";
    private static final float probabilidad_nueva_letra = .8f;
    // Configuración.
    
    private static boolean trabajando = true;
    private static PrintWriter salida;

    /**
     * @param args the command line arguments
     */
    public static void main(String[] args) {
        // TODO code application logic here
        
        System.out.println(Arrays.toString(args));
        
        if(args.length == 2){
            numero_de_palabras = Integer.parseInt(args[0]);
            path = args[1];
        }
        
        try {

            Socket socket = new Socket(host, puerto);
            salida = new PrintWriter(socket.getOutputStream());
            BufferedReader lectura = new BufferedReader(new InputStreamReader(socket.getInputStream()));
            
            new Thread(new Runnable(){
                @Override
                public void run() {
                    
                    String mensaje;
                    int palabras_creadas = 0;
                    
                    try{
                        while((mensaje = lectura.readLine()) != null){
                            System.out.println("CLIENTE - REC => " + mensaje);
                            String[] resultados = mensaje.split(" ");
                            switch(resultados[0]){
                                case "permiso" -> {
                                    if(resultados[1].equals("Sí")){
                                        escribir_palabra();
                                        enviar("terminado");
                                        System.out.println("Palabra #" + palabras_creadas + " de " + numero_de_palabras + ".");
                                        if((palabras_creadas += 1) >= numero_de_palabras){
                                            enviar("cerrar");
                                            trabajando = false;
                                        }
                                    }
                                    if(trabajando)
                                        try {
                                            Thread.sleep((long) (Math.random() * 100));
                                            enviar("permiso");
                                        } catch (InterruptedException excepcion) {
                                            Lenguaje.excepcion(excepcion);
                                        }
                                }
                            }
                        }
                        lectura.close();
                    } catch (IOException excepcion) {
                        Lenguaje.excepcion(excepcion);
                    }
                }
            }).start();
            
            enviar("permiso");
            
        }catch(IOException ex){
            escribir_fichero();
        }
        
    }
    
    private static boolean enviar(String mensaje){
        
        boolean estado = false;
        
        try{
            new Thread(new Runnable(){
                @Override
                public void run() {
                    System.out.println("CLIENTE - ENV => " + mensaje);
                    salida.println(mensaje);
                    salida.flush();
                }
            }).start();
            estado = true;
        }catch(Exception excepcion){
            Lenguaje.excepcion(excepcion);
        }
        
        return estado;
    }
    
    public static String crear_palabra(){
        
        String palabra = "";
        int l = alfabeto.length();
        
        while(palabra.length() < 3 || Math.random() < probabilidad_nueva_letra)
            palabra += alfabeto.charAt((int)(Math.random() * l));
        
        return palabra;
    }
    
    public static void escribir_palabra(){
        
        File archivo = new File(path);
        
        if(!archivo.exists())
            try {
                archivo.createNewFile();
            } catch (IOException excepcion) {
                Lenguaje.excepcion(excepcion);
            }
        
        try (BufferedWriter escritura = new BufferedWriter(new FileWriter(archivo, true))) {
            escritura.append(Lenguaje.crear_palabra() + "\n");
        }catch(FileNotFoundException excepcion){
            Lenguaje.excepcion(excepcion);
        }catch(IOException excepcion){
            Lenguaje.excepcion(excepcion);
        }
        
    }

    public static void escribir_fichero(){
        for(int i = 0; i < numero_de_palabras; i ++)
            escribir_palabra();
    }
    
    private static void excepcion(Exception exception){
        System.out.println(exception.getMessage());
        System.out.println(Arrays.toString(exception.getStackTrace()));
    }
    
}
